// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#include "Customer.h"
#include <cmath>



namespace PSASP {



// ...
Customer::Customer (int x, int y):
    x (x), y (y) {}



// ...
Customer::Customer (const Customer &c):
    x (c.x), y (c.y) {}



// ...
const Customer &Customer::operator= (const Customer &c) {
    x = c.x;
    y = c.y;
    return *this;
}



// ...
double Customer::distance (const Customer &c) const {
    return sqrt (sqr (c.x - x) + sqr (c.y - y));
}



// ...
void Customer::exchange (Customer &c) {
    int tmp_x = c.x;
    int tmp_y = c.y;
    
    c.x = this->x;
    c.y = this->y;
    this->x = tmp_x;
    this->y = tmp_y;

    return;
}



// ...
bool operator== (const Customer &l, const Customer &r) {
    return (l.x == r.x  &&  l.y == r.y);
}



} // namespace PSASP
