// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#include <iostream>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include "Main.h"
#include "Solution.h"



namespace PSASP {



// ...
Main::Main (int map_size, char *map_filename, int thread_count, bool prop_results):
    map_size (map_size),
    map_filename (map_filename),
    thread_count (thread_count),
    prop_results (prop_results),
    best_solution (map_size),
    equilibrium_counter (0),
    working (true),
    temperature (0.0),
    alpha (ALPHA_INIT),
    main_barrier (thread_count + 1),
    help_barrier (thread_count) {
    
    if (this->map_filename  !=  "")
        this->best_solution.init (this->map_filename);
    else
        this->best_solution.init ();
    this->temperature = this->best_solution.cost * INITIAL_TEMPERATURE_MULTIPLIER;
}



// ...
void Main::body () {
	for (int i = 0;  i < this->thread_count;  i++) {
	    tasks.push_back (Task (this, i));
	}

    this->main_barrier.wait ();

	for (int i = 0;  i < tasks.size ();  i++) {
	    tasks[i].try_stop ();
	}
}



} // namespace PSASP
