// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#ifndef __MAIN_H_
#define __MAIN_H_ 1



#include <vector>
#include <list>
#include <boost/thread/mutex.hpp>
#include "Customer.h"
#include "Route.h"
#include "Task.h"
#include "Solution.h"



#define INITIAL_TEMPERATURE_MULTIPLIER 0.001
#define ALPHA_INIT 0.95
#define MAP_SIZE_INIT 45
#define THREAD_COUNT_INIT 1
#define THREAD_COUNT_MAX 32
#define EQUILIBRIUM_STEPS_INIT 20
#define MAX_MAP_SIZE 30000



namespace PSASP {



class Task;



// ...
class Main {

    private:

    public:

        // ...
        int map_size;

		// ...
		char *map_filename;
      
        // ...
        int thread_count;
        
        // ...
        bool prop_results;
        
        // ...
        static const int equilibrium_steps = EQUILIBRIUM_STEPS_INIT;
        
        // ...
        bool working;
        
        // ...
		Solution best_solution;
	
		// ...
		int equilibrium_counter;
		
		// ...
		double temperature;
		
		// ...
		double alpha;
		
		// ...
		std::vector<Task> tasks;
        
        // ...
        boost::mutex main_mutex;
        
        // ...
        boost::mutex cout_mutex;
                
        // ...
        boost::barrier main_barrier;
        
        // ...
        boost::barrier help_barrier;
        
        
        
        // ...
        Main (int map_size, char* map_filename, int thread_count, bool prop_results);

        // ...
        void body ();

};



} // end namespace PSASP



#endif
