// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#ifndef __ROUTE_H_
#define __ROUTE_H_ 1



#include "Customer.h"
#include <list>
#include <stdexcept>



namespace PSASP {



// ...
class Route {

    private:

        // ...
        double euclidean_length;
        
        // ...
        Customer &base;



    public:
    
        // ...
        std::list<Customer> path;



        // ...
        Route (Customer &base);

        // ...
        Route (const Route &r);

        // ...
        const Route &operator= (const Route &r);

        // ...
        bool add (const Customer &c, double *length_delta);
        
        // ...
        bool add (const Customer &c);

        // ...
        void remove (const Customer &c, double *length_delta);
        
        // ...
        void remove (const Customer &c);

        // ...
        double recompute_length ();

        // ...
        double length () const;
        
        // ...
        Customer &get_random_customer () throw (std::range_error);
        
};



} // end namespace PSASP



#endif
