// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#ifndef __SOLUTION_H_
#define __SOLUTION_H_ 1

#include "Customer.h"
#include "Route.h"
#include <boost/optional.hpp>
#include <list>
#include <vector>



namespace PSASP {



// ...
class Solution {

    public:
    
        // ...
        Customer base;
        
        // ...
        std::list<Route> route_list;
        
        // ...
        std::vector< boost::optional<std::list<Route>::iterator> >  route_random_access_table;
        
        // ...
        double cost;
        
        // ...
        int map_size;



        // ...
        Solution (int map_size);
        
        // ...
        Solution (const Solution &s);
        
        // ...
        void init ();
        
        // ...
        void init (char *map_filename);
        
        // ...
        const Solution &operator= (const Solution &s);
        
        // ...
        std::list<Route>::iterator get_random_route (bool potentially_with_new_empty_route, int *rat_id);
        
        // ...
		double compute_cost ();
        
        // ...
        double compute_cost (double delta);
        
        // ...
        void print () const;

};



} // end namespace PSASP



#endif
