// Parallel Simulated Annealing
// for the Set-partitioning Problem
// Mateusz Styrczula, Michał Kraszewski
// 13.01.2009



#ifndef __TASK_H_
#define __TASK_H_ 1


#include <list>
#include <boost/thread.hpp>
#include <boost/bind.hpp>
#include <boost/thread/mutex.hpp>
#include "Route.h"
#include "Solution.h"
#include "Main.h"



namespace PSASP {



class Main;



// ...
class Task {

    private:

        // ...
        bool thread_running;
        
        // ...
        int task_id;
        
        // ...
        boost::thread *thread;
        
        // ...
        Main *main;
        
        // ...
		int iteration_counter;
        
        

    public:
    
        // ...
        Solution current_solution, best_local_solution;
        
        // ...
        boost::mutex sending_mutex;
        
        // ...
        boost::mutex receiving_mutex;



        // ...            
        Task (Main *m, int task_id);
        
        // ...
        Task (const Task &t);

        // ...
        const Task &operator= (const Task &t);       

        // ...
        void start ();

        // ...
        void try_stop ();

        // ...
        void operator() ();

        // ...
        void body ();
        
        // ...
        void annealing_step (unsigned long *missed, unsigned long *lucky_loose, unsigned long *hitted);

};



} // end namespace PSASP



#endif
